// C Header File
// Created 7/15/01; 1:15:28 PM

#ifndef _SSTARTH_
#define _SSTARTH_

///////////////////////////////
//Conditional compilation directives
//#define LeakWatch				//Reports gain/loss of ram after executing the program
//////////////////////////////

//////////////////////////////
//Title/Version info
#define APP_TITLE "sstart"
#define APP_VERSION "v1.1"
//////////////////////////////

/////////////////////////////
//Text Strings
#define TXT_LOW_RAM 				"Low RAM"
#define TXT_BAD_PPG 				"Bad ppg file"
#define TXT_DECOMPRESSING		"decompressing..."
#define TXT_FILE_TYPE				"Must be ASM or ppg file"
#define TXT_FILE_NOT_FOUND	"%s not found"
#define TXT_HELP						APP_TITLE" "APP_VERSION" use "APP_TITLE"(\"name\")"
#define TXT_LEAK_WATCH			"RAM Gained/Lost: %ld"
//////////////////////////////

//////////////////////////////
//Error routines
#define fatal(s) {ST_showHelp(s); return;}
#define fatal2(s) {HeapUnlock(h);fatal(s)}
//////////////////////////////

//////////////////////////////
//Error messages after HANDLE h has been locked
#define EXIT_LOW_RAM()			fatal2(TXT_LOW_RAM)
#define EXIT_BAD_PPG()			fatal2(TXT_BAD_PPG)
//////////////////////////////

//////////////////////////////
//For RETURN_VALUE if used in called program
#define ASM_NOP_CALL(x) ({\
asm volatile("movem.l %d0-%d7/%a0-%a6,-(%sp)"); \
ASM_fastcall(x);\
asm volatile("nop;nop;nop;nop;");\
asm volatile("movem.l (%sp)+,%d0-%d7/%a0-%a6");})

//////////////////////////////

//////////////////////////////
//For LeakWatch
#undef	HomePushEStack
#define HomePushEStack	_rom_call(void,(void),10F)
//////////////////////////////
#endif
